<template>
  <v-container fill-height>
    <v-layout row wrap align-center>
      <v-flex xs10 sm10 offset-sm1>
        <v-card>
          <v-card-title primary-title>
            <h3 class="headline mb-0">CollegiumV Account Creation</h3>
          </v-card-title>

            <v-stepper v-model="progress">
              <v-stepper-header>
                <v-stepper-step step="1" :complete="progress > 1" >Personal Details</v-stepper-step>
                <v-divider></v-divider>
                <v-stepper-step step="2" :complete="progress > 2" >Account Details</v-stepper-step>
                <v-divider></v-divider>
                <v-stepper-step step="3">Confirmation</v-stepper-step>
              </v-stepper-header>
              <v-stepper-items>
                <v-stepper-content step="1">
                  <v-card class="mb-5" flat>
                    <v-form v-model="form1">
                      <v-container fluid>
                        <v-layout row>
                          <v-flex xs4>
                            <v-subheader>First Name</v-subheader>
                          </v-flex>
                          <v-flex xs8>
                            <v-text-field v-model="firstName"
                               id="first_name"
                               :label="firstNameDisplay"
                               :disabled="firstNameDisabled"
                               :rules="[v => !!firstNameValue || 'First name is required']"
                               ></v-text-field>
                          </v-flex>
                        </v-layout>
                        <v-layout row>
                          <v-flex xs4>
                            <v-subheader>Last Name</v-subheader>
                          </v-flex>
                          <v-flex xs8>
                            <v-text-field v-model="lastName"
                               :label="lastNameDisplay"
                               id="last_name"
                               :disabled="lastNameDisabled"
                               :rules="[v => !!lastNameValue || 'Last name is required']"
                               ></v-text-field>
                          </v-flex>
                        </v-layout>
                        <v-layout row>
                          <v-flex xs4>
                            <v-subheader>Email Address</v-subheader>
                          </v-flex>
                          <v-flex xs8>
                            <v-text-field v-model="email"
                               :label="emailDisplay"
                               id="email"
                               :disabled="emailDisabled"
                               :rules="[v => !!emailValue || 'Email Address is required']"
                               ></v-text-field>
                          </v-flex>
                        </v-layout>
                      </v-container>
                    </v-form>
                  </v-card>
                  <v-btn color="primary"
                    @click.native="progress = 2" :disabled="!form1">Continue</v-btn>
                </v-stepper-content>
                <v-stepper-content step="2">
                  <v-card class="mb-5" flat>
                    <v-form v-model="form2">
                      <v-container fluid>
                        <v-layout row>
                          <v-flex xs4>
                            <v-subheader>Username</v-subheader>
                          </v-flex>
                          <v-flex xs8>
                            <v-text-field v-model="uid"
                              :rules="requiredRule"
                              label="Username"
                              id="username"
                              hint="This can be anything :)"
                              ></v-text-field>
                          </v-flex>
                        </v-layout>
                        <v-layout row>
                          <v-flex xs4>
                            <v-subheader>Password</v-subheader>
                          </v-flex>
                          <v-flex xs8>
                            <v-text-field v-model="password"
                              label="Password"
                              id="password"
                              :rules="requiredRule"
                              :append-icon="passwordHidden ? 'visibility' : 'visibility_off'"
                              :append-icon-cb="() => (passwordHidden = !passwordHidden)"
                              :type="passwordHidden ? 'password' : 'text'"
                              ></v-text-field>
                          </v-flex>
                        </v-layout>
                        <v-layout row>
                          <v-flex offset-xs4>
                            <v-switch label="Send a slack invite?" v-model="slackInvite"></v-switch>
                          </v-flex>
                        </v-layout>
                        <v-layout row v-if="uidChecked">
                          <v-flex offset-xs4>
                            <v-icon :color="uidColor">{{ uidIcon }}</v-icon>
                            <span>{{ uidText }}</span>
                          </v-flex>
                        </v-layout>
                      </v-container>
                    </v-form>

                  </v-card>
                  <v-btn flat @click.native="progress = 1">Back</v-btn>
                  <v-btn color="primary"
                    @click.native="progress = 3" :disabled="!form2">Continue</v-btn>
                </v-stepper-content>
                <v-stepper-content step="3">
                  <v-card class="mb-5" flat>
                    <v-container fluid>
                      <v-layout row>
                        <v-flex xs4>
                          <v-subheader>First Name</v-subheader>
                        </v-flex>
                        <v-flex xs8>
                          <v-text-field :label="firstNameValue"
                                        :disabled="true"
                                        ></v-text-field>
                        </v-flex>
                      </v-layout>
                      <v-layout row>
                        <v-flex xs4>
                          <v-subheader>Last Name</v-subheader>
                        </v-flex>
                        <v-flex xs8>
                          <v-text-field :label="lastNameValue"
                                        :disabled="true"
                                        ></v-text-field>
                        </v-flex>
                      </v-layout>
                      <v-layout row>
                        <v-flex xs4>
                          <v-subheader>Email Address</v-subheader>
                        </v-flex>
                        <v-flex xs8>
                          <v-text-field :label="emailValue"
                                        :disabled="true"
                                        ></v-text-field>
                        </v-flex>
                      </v-layout>
                      <v-layout row>
                        <v-flex xs4>
                          <v-subheader>Username</v-subheader>
                        </v-flex>
                        <v-flex xs8>
                          <v-text-field :label="uid"
                                        :disabled="true"
                                        ></v-text-field>
                        </v-flex>
                      </v-layout>
                      <v-layout row>
                        <v-flex xs4>
                          <v-subheader>Slack Invite</v-subheader>
                        </v-flex>
                        <v-flex xs8>
                            <v-checkbox :input-value="slackInvite"></v-checkbox>
                        </v-flex>
                      </v-layout>
                    </v-container>
                  </v-card>
                  <v-btn flat @click.native="progress = 2">Back</v-btn>
                  <v-btn color="primary" @click.native="create()">Create Account</v-btn>
                </v-stepper-content>
              </v-stepper-items>
            </v-stepper>

          <v-snackbar top :timeout="timeout" v-model="errorSnackbar" color="error" >
            {{ errorText }}
          </v-snackbar>

            <v-snackbar top :timeout="timeout" v-model="successSnackbar" color="success" >
              {{ successText }}
            </v-snackbar>

        </v-card>
      </v-flex>
    </v-layout>
  </v-container>
</template>

<script>
import axios from 'axios';
import _ from 'lodash';

export default {
  data: () => ({
    progress: 1,
    form1: true,
    form2: true,
    form3: true,
    passwordHidden: true,
    firstName: '',
    lastName: '',
    email: '',
    uid: '',
    uidText: '',
    uidIcon: '',
    uidColor: 'grey',
    password: '',
    uidChecked: false,
    slackInvite: false,
    successSnackbar: false,
    errorSnackbar: false,
    successText: '',
    errorText: '',
    timeout: 6000,

    requiredRule: [
      v => !!v || 'This field is required',
    ],
  }),
  watch: {
    uid: function checkUid() {
      if (this.uid === '') {
        this.uidChecked = false;
      } else {
        this.findUid();
      }
    },
  },
  methods: {
    findUid: _.debounce(function check() {
      this.uidText = `Checking whether ${this.uid} is available`;
      this.uidIcon = 'help';
      this.uidColor = 'info';
      this.uidChecked = true;
      axios.post('/api/checkuid', {
        uid: this.uid,
      }).then((response) => {
        if (response.data === 'true') {
          this.uidIcon = 'check_circle';
          this.uidColor = 'success';
          this.uidText = `${this.uid} is available`;
        } else {
          this.uidIcon = 'error';
          this.uidColor = 'error';
          this.uidText = `Sorry, "${this.uid}" is not available`;
        }
      }).catch(() => {
        this.uidIcon = 'mood_bad';
        this.uidColor = 'info';
        this.uidText = `Could not check if "${this.uid}" is available`;
      });
    },
    500),

    create() {
      axios.post('/api/create', {
        uid: this.uid,
        password: this.password,
        firstName: this.firstNameValue,
        lastName: this.lastNameValue,
        email: this.emailValue,
        slack: this.slackInvite,
        token: this.token,
      }).then(() => {
        this.successText = 'Congrats! Your account has been created';
        this.successSnackbar = true;
      }).catch(() => {
        this.errorText = 'Oops! An error occurred. Please try again later.';
        this.errorSnackbar = true;
      });
    },
  },
  computed: {
    token: function token() {
      // test
      return window.atob(this.$route.params.token);
    },
    claims: function getClaims() {
      const base64Url = this.token.split('.')[1];
      const base64 = base64Url.replace('-', '+').replace('_', '/');
      return JSON.parse(window.atob(base64));
    },
    firstNameDisplay: function getFirstName() {
      if ('firstName' in this.claims) {
        return this.claims.firstName;
      }
      return 'First Name';
    },
    lastNameDisplay: function getLastName() {
      if ('lastName' in this.claims) {
        return this.claims.lastName;
      }
      return 'Last Name';
    },
    emailDisplay: function getLastName() {
      if ('email' in this.claims) {
        return this.claims.email;
      }
      return 'email@utdallas.edu';
    },

    firstNameDisabled: function a() {
      if (this.firstNameDisplay === 'First Name') {
        return false;
      }
      return true;
    },
    lastNameDisabled: function a() {
      if (this.lastNameDisplay === 'Last Name') {
        return false;
      }
      return true;
    },
    emailDisabled: function a() {
      if (this.emailDisplay === 'email@utdallas.edu') {
        return false;
      }
      return true;
    },
    firstNameValue: function a() {
      if (this.firstNameDisabled) {
        return this.firstNameDisplay;
      }
      return this.firstName;
    },
    lastNameValue: function a() {
      if (this.lastNameDisabled) {
        return this.lastNameDisplay;
      }
      return this.lastName;
    },
    emailValue: function a() {
      if (this.emailDisabled) {
        return this.emailDisplay;
      }
      return this.email;
    },
  },
};
</script>

<style scoped>
</style>
